// https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest

function sendFileToServer(formData, status) {
	var jqXHR = $.ajax({
		xhr: function() {
			var xhrobj = $.ajaxSettings.xhr();
			if (xhrobj.upload) {
				xhrobj.upload.addEventListener('progress', function(event) {
					var percent = 0;
					var position = event.loaded || event.position;
					var total = event.total;
					if (event.lengthComputable) {
						percent = Math.ceil(position / total * 100);
					}
					status.setProgress(percent);
				}, false);
			}
			return xhrobj;
		},
		url: 'upload.php',
		type: "POST",
		contentType: false,
		processData: false,
		cache: false,
		data: formData,
		success: function(data) {
			status.setProgress(100);
		}
	});
	status.setAbort(jqXHR);
}

function createStatusbar(obj) {
	this.str = $('<div class="statusbar"><div class="info"></div><div class="progressBar"><div></div></div><div class="abort">Abort</div></div>');

	$('.progress_tracker').append(this.str);
	this.setFileNameSize = function(name, size) {
		var sizeStr = "";
		var sizeKB = size / 1024;

		if (parseInt(sizeKB, 10) > 1024) {
			var sizeMB = sizeKB / 1024;
			sizeStr = sizeMB.toFixed(2) + " MB";
		} else {
			sizeStr = sizeKB.toFixed(2) + " KB";
		}

		$(this.str).find('.info').html(name + ' (' + sizeStr + ')');
	};

	this.setProgress = function(progress) {
		var progressBarWidth = progress * $(this.str).find('.progressBar').width() / 100;
		$(this.str).find('.progressBar div').animate({
			width: progressBarWidth
		}, 10).html(progress + "% ");
	};

	this.setAbort = function(jqxhr) {
		var sb = $(this.str);
		$(this.str).find('.abort').click(function() {
			jqxhr.abort();
			sb.hide();
		});
	};
}

function handleFileUpload(files, obj) {
	for (var i = 0; i < files.length; i++) {
		var fd = new FormData();
		fd.append('file', files[i]);
		var status = new createStatusbar(obj);
		status.setFileNameSize(files[i].name, files[i].size);
		sendFileToServer(fd, status);
	}
}

$(document).ready(function() {
	var obj = $(".dropArea");

	obj.on('dragenter', function(e) {
		e.stopPropagation();
		e.preventDefault();
		$(this).css('border', 'solid 1px rgb(64, 118, 182)');
	});

	obj.on('dragover', function(e) {
		e.stopPropagation();
		e.preventDefault();
	});

	obj.on('drop', function(e) {
		e.preventDefault();
		$(this).css('border', 'solid 1px rgb(64, 118, 182)');
		var files = e.originalEvent.dataTransfer.files;
		handleFileUpload(files, obj);
	});
});